#include "PsxCommon.h"
#include <SDL/SDL.h>

// For Exit function
void psxShutdown();
// For framerate debug
void MyLog(char *fmt, ...);
void dtext(int x, int y, char * lpString);

long  PadFlags = 0;
extern int frameRate;
extern int framesToSkip;
extern char *packfile;
extern unsigned long displayNumber;
extern char framesToSkipText[256];
extern int drawToDrawingArea;
extern unsigned long mStopEmulation;
extern unsigned int g_confinput[20];
extern unsigned int g_translateBtn[20];

long PAD1_init(long flags) {
	//SysPrintf("start PAD_init()\r\n");

//	printf("Flags: %08x\n", flags);
	PadFlags |= flags;

	/* Read Configuration here */

	//SysPrintf("end PAD_init()\r\n");
	
	return 0;
}

long PAD2_init(long flags) {
	//SysPrintf("start PAD_init()\r\n");

//	printf("Flags: %08x\n", flags);
	PadFlags |= flags;

	/* Read Configuration here */

	//SysPrintf("end PAD_init()\r\n");
	
	return 0;
}

long PAD1_shutdown(void) {
	return 0;
}


long PAD2_shutdown(void) {
	return 0;
}


long PAD1_open(void)
{
	//SysPrintf("start PAD1_open()\r\n");
//	c = maple_first_controller();
	//SysPrintf("end PAD1_open()\r\n");
	return 0;
}


long PAD2_open(void)
{
	//SysPrintf("start PAD1_open()\r\n");
//	c = maple_first_controller();
	//SysPrintf("end PAD1_open()\r\n");
	return 0;
}


long PAD1_close(void) {
	return 0;
}


long PAD2_close(void) {
	return 0;
}

//extern BOOL bSkipNextFrame;

unsigned short ReadZodKeys()
{
	unsigned short pad_status = 0xffff;
	int numkeys;
	unsigned char* keys;

	// Pump events so keys can be read properly
	SDL_PumpEvents();

	// Read key state
	keys = SDL_GetKeyState(&numkeys);
	
	if ( keys[SDLK_BACKSPACE] )
	{
		psxShutdown();
		ClosePlugins();
		ReleasePlugins();
	
		// close SDL
		SDL_Quit();

		exit(0);
	}
	
	if( keys[SDLK_p] )
	{
		drawToDrawingArea = !drawToDrawingArea;
		return pad_status;
	}
	else if( keys[SDLK_k] )
	{
		if( framesToSkip > 0 )
		{
			framesToSkip--;
		}
		sprintf(framesToSkipText, "Frameskip: %d Framerate: %d", framesToSkip, frameRate);
		sleep(1);
		return pad_status;
	}
	else if( keys[SDLK_l] ) 
	{
		if( framesToSkip < 20 )
		{
			framesToSkip++;
		}
		sprintf(framesToSkipText, "Frameskip: %d Framerate: %d", framesToSkip, frameRate);
		sleep(1);
		return pad_status;
	}


	if ( keys[SDLK_UP] )
	{
		pad_status &= ~(1<<4); 
	}
	if ( keys[SDLK_DOWN] )
	{
		pad_status &= ~(1<<6);
	}
	if ( keys[SDLK_LEFT] )
	{
		pad_status &= ~(1<<7);
	}
	if ( keys[SDLK_RIGHT] )
	{
		pad_status &= ~(1<<5);
	}
	if ( keys[SDLK_RETURN] )
	{
		pad_status &= ~(1<<3);
	}
	if ( keys[SDLK_SPACE] )
	{			
		pad_status &= ~(1<<2);
	}
	if ( keys[SDLK_z] )
	{
		pad_status &= ~(1<<10); // L ?
	}
	if ( keys[SDLK_x] )
	{
		pad_status &= ~(1<<11); // R ?
	}
		
	if ( keys[SDLK_d] )
	{
		pad_status &= ~(1<<14);
	}
	if ( keys[SDLK_f] )
	{
		pad_status &= ~(1<<13);
	}
	if ( keys[SDLK_a] ) // left button
	{
		pad_status &= ~(1<<15);
	}
	if ( keys[SDLK_s] ) // top button
	{
		pad_status &= ~(1<<12);
	}		
	
	if( keys[SDLK_c] ) // L2
	{
		pad_status &= ~(1<<8);
	}
	if( keys[SDLK_v] ) // R2
	{
		pad_status &= ~(1<<9);
	}

	return pad_status;
}

long PAD1_readPort1(PadDataS* pad) {
	unsigned short pad_status = 0xffff;
	//SysPrintf("start PAD1_readPort()\r\n");
	pad_status = ReadZodKeys();
	pad->buttonStatus = pad_status;
	pad->controllerType = 4; // standard	
  	return 0;
}

long PAD2_readPort1(PadDataS* pad) {
	unsigned short pad_status = 0xffff;
	SysPrintf("start PAD1_readPort()\r\n");
	pad_status = 0xffff;
	pad->buttonStatus = pad_status;
	pad->controllerType = 4; // standard
 	return 0;
}

long PAD1_readPort2(PadDataS* a) {
	return -1;
}

long PAD2_readPort2(PadDataS* a) {
	return -1;
}
