/***********************************************************************
*
*	Dr.Hell's WinGDI GPU Plugin
*	Version 0.8
*	Copyright (C)Dr.Hell, 2002-2004
*
*	Device Depended
*
***********************************************************************/

extern SDL_Surface* sdlscreen;

/*----------------------------------------------------------------------
Compatibility
----------------------------------------------------------------------*/

#define CALLBACK 

/*----------------------------------------------------------------------
Constant
----------------------------------------------------------------------*/

#define	VIDEO_BUFFER_SIZE	(640*480*3)

/*----------------------------------------------------------------------
Macro
----------------------------------------------------------------------*/

#define	GetMem(p1)	malloc((p1))
#define	FreeMem(p1)	free((p1))
#define CopyMemory(Destination,Source,Length) memcpy((Destination),(Source),(Length))
#define ZeroMemory(Destination,Length) memset((Destination),0,(Length))
#define	CopyMem(p1,p2,p3)	CopyMemory((p1),(p2),(p3))
#define	ZeroMem(p1,p2)	ZeroMemory((p1),(p2))

/*----------------------------------------------------------------------
Global
----------------------------------------------------------------------*/

// My Framskip Globals
int	drawToDrawingArea = 0;
char framesToSkipText[256];
int framesSkipped;
int framesToSkip = 0;
int	frameRateCounter;
int frameRate;
time_t systime;

uchar *VideoBuffer;
//HINSTANCE WinInst;
//HWND WinWND;
//HDC WinDC;
//long WinWidth = 320;
//long WinHeight = 240;
//long WinStretch = BST_UNCHECKED;
//long WinEntire = BST_UNCHECKED;

void dtext(int x, int y, char * lpString);

/*----------------------------------------------------------------------
Entry Point
----------------------------------------------------------------------*/
#if 0
BOOL WINAPI DllMain(HINSTANCE hinstDLL, ulong fdwReason,
					LPVOID lpvReserved)
{
	WinInst = hinstDLL;
	return (TRUE);
}
#endif
/*----------------------------------------------------------------------
gpuGetTime
----------------------------------------------------------------------*/

ulong gpuGetTime(void)
{
	// System time in milliseconds
	return (clock());
}

/*----------------------------------------------------------------------
gpuLoadConfig
----------------------------------------------------------------------*/
#if 0
#define	GPU_REG "Software\\Vision Thing\\PSEmu Pro\\GPU\\HellGDI"

#define	GPU_READREG(s,v)												\
{																		\
	cbData = 4;															\
	RegQueryValueEx(hKey, (s), NULL, &dwType, (void *) (v), &cbData);	\
}
#endif
void gpuLoadConfig(void)
{
#if 0
	ulong cbData, dwType;
	HKEY hKey;
	if (ERROR_SUCCESS !=
		RegOpenKeyEx(HKEY_CURRENT_USER, GPU_REG, NULL, KEY_ALL_ACCESS,
					 &hKey))
		return;
	GPU_READREG("DrawingCount0", &DrawingCount[0]);
	GPU_READREG("DrawingCount1", &DrawingCount[1]);
	GPU_READREG("DisplayCount0", &DisplayCount[0]);
	GPU_READREG("WinWidth", &WinWidth);
	GPU_READREG("WinHeight", &WinHeight);
	GPU_READREG("WinStretch", &WinStretch);
	GPU_READREG("WinEntire", &WinEntire);
	RegCloseKey(hKey);
	if (!DisplayCount[0])
		DisplayCount[0] = 1000030 / 60;
	if (!WinWidth)
		WinWidth = 640;
	if (!WinHeight)
		WinHeight = 480;

#endif
	DisplayCount[0] = 16714;
	DrawingCount[0] = 0;
	DrawingCount[1] = 2;
}

/*----------------------------------------------------------------------
gpuSaveConfig
----------------------------------------------------------------------*/
#if 0
#define	GPU_WRITEREG(s,v)												\
{																		\
	RegSetValueEx(hKey, (s), 0, REG_DWORD, (void *) (v), 4);			\
}
#endif
void gpuSaveConfig(void)
{
#if 0
	ulong dwDisposition;
	HKEY hKey;
	RegCreateKeyEx(HKEY_CURRENT_USER, GPU_REG, 0, NULL,
				   REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey,
				   &dwDisposition);
	GPU_WRITEREG("DrawingCount0", &DrawingCount[0]);
	GPU_WRITEREG("DrawingCount1", &DrawingCount[1]);
	GPU_WRITEREG("DisplayCount0", &DisplayCount[0]);
	GPU_WRITEREG("WinWidth", &WinWidth);
	GPU_WRITEREG("WinHeight", &WinHeight);
	GPU_WRITEREG("WinStretch", &WinStretch);
	GPU_WRITEREG("WinEntire", &WinEntire);
	RegCloseKey(hKey);
#endif
}

/*----------------------------------------------------------------------
gpuOpenVideo
----------------------------------------------------------------------*/

void gpuOpenVideo(long p1)
{
//	long w0, h0;
//	RECT r0, r1;
//	VideoBuffer = GetMem(VIDEO_BUFFER_SIZE);
//	WinWND = (HWND) p1;
//	WinDC = GetDC(WinWND);
//	SetStretchBltMode(WinDC, HALFTONE);
	gpuLoadConfig();
//	w0 = WinWidth;
//	h0 = WinHeight;
//	GetWindowRect(WinWND, &r0);
//	GetClientRect(WinWND, &r1);
//	w0 += ((r0.right - r0.left) - (r1.right - r1.left));
//	h0 += ((r0.bottom - r0.top) - (r1.bottom - r1.top));
//	SetWindowPos(WinWND, HWND_TOPMOST, 2, 2, w0, h0, 0);

#if 1
 systime = time(NULL);
 framesSkipped = 0;
 framesToSkip = 1;
 frameRateCounter = 0;
 frameRate = 60;
#endif
}

/*----------------------------------------------------------------------
gpuCloseVideo
----------------------------------------------------------------------*/

void gpuCloseVideo(void)
{
//	ReleaseDC(WinWND, WinDC);
//	FreeMem(VideoBuffer);
}

/*----------------------------------------------------------------------
gpuVideoOutput
----------------------------------------------------------------------*/

void gpuVideoOutput(void)
{
#if 1
	unsigned long diffintime = 0;
	time_t	newtime;
	int pos, inc;
	int pos2, inc2;
	int dst_maxrow;
	int src_row, dst_row;
	unsigned char *srcp = 0;
	unsigned char *dstp;
	unsigned char *srcp8;
	unsigned short *srcp16;
	unsigned short *dstp16;
	int i;
	unsigned short pixel16;
	unsigned char pixel[3];

	short x0, y0, w0, h0, h1;

	if (GP1 & 0x00800000)
		return;

#if 0
	// temp placed here
	w0 = 1024;//DisplayArea[2];
	h0 = 512; //DisplayArea[3];
	x0 = 0; y0 = 0;
#endif

#if 1
	// Blackout screen fix
	if( drawToDrawingArea == 1 )
	{
		x0 = DisplayArea[0]; //DrawingArea[0];
		y0 = DisplayArea[0]; //DrawingArea[1];
	}
	else
	{
		x0 = 0; //DisplayArea[0];
		y0 = 0; //DisplayArea[1];
	}

	w0 = DisplayArea[2];
	h0 = DisplayArea[3];
#endif

	// start frameskip
/*
	if( Skip == 0 && framesToSkip > 0 ) DrawingCount[0] = framesToSkip * 2 - 1;

	if( Skip == 0 )
	{
		Skip = DrawingCount[0];
	}
	else
	{
		Skip--;
		return;
	}
*/
	if( framesSkipped >= framesToSkip )
	{	
		framesSkipped = 0;
		// set rendering skipping
		//Skip = framesToSkip - framesSkipped;
	}
	else
	{
		framesSkipped++;
		return;
	}

	frameRateCounter++;
	if( frameRateCounter >= 300 )
	{
		newtime = time(NULL);
		diffintime = difftime(newtime, systime);
		systime = newtime;
		frameRate = 300 / diffintime;
		frameRateCounter = 0;	
	}

	if( w0 == sdlscreen->w &&
		h0 == sdlscreen->h )
	{
		// Fast Blit
		if( GP1 & 0x00200000 )
		{
			unsigned short* dst;
			unsigned char*	src = (unsigned char *) FrameBuffer;
			unsigned long iX;
			unsigned long startxy = y0*(1024*2)+(x0*2);

			SDL_LockSurface(sdlscreen);
			// xxx: doesn't check for null!
			dst = (unsigned short*)sdlscreen->pixels;

			while( h0-- )
			{
				iX = w0;
				while( iX-- )
				{
					*dst++ = gp2x_video_RGB_color16(src[startxy],src[startxy+1],src[startxy+2]);
					startxy += 3;
				}
				startxy += 2048-(w0*3)+(x0*2);
			}

			SDL_UnlockSurface(sdlscreen);
		}
		else
		{
			unsigned short* dst;
			unsigned short* src = (unsigned short*) FrameBuffer;
			unsigned long iX;

			SDL_LockSurface(sdlscreen);
			// xxx: doesn't check for null!
			dst = (unsigned short*)sdlscreen->pixels;

			src += y0*1024+x0;
			while( h0-- )
			{
				iX = w0;
				while( iX-- )
				{
					*dst++ = (unsigned short)((((*src)<<11)&0xf800f800)|(((*src)<<1)&0x7c007c0)|(((*src)>>10)&0x1f001f));
					src++;
				}
				src += 1024 - sdlscreen->w + x0; //1024-w0+x0;
			}

			SDL_UnlockSurface(sdlscreen);
		}
	}
	else
	{
		// stretch blit
		pos = 0x10000;
		inc = (h0 << 16) / sdlscreen->h;
		src_row = y0;
		dst_row = 0;

		SDL_LockSurface(sdlscreen);
		// xxx: doesn't check for null sdlscreen!
		
		for ( dst_maxrow = dst_row+sdlscreen->h; dst_row<dst_maxrow; ++dst_row ) 
		{
			dstp = (unsigned char *)sdlscreen->pixels + (dst_row*(sdlscreen->w*2));
			while ( pos >= 0x10000L ) 
			{
				srcp = (unsigned char *)FrameBuffer + (src_row*2048) + (x0*2);
				++src_row;
				pos -= 0x10000L;
			}

			if( GP1 & 0x00200000 )
			{
				srcp8 = srcp;
				dstp16 = (unsigned short*)dstp;
				pos2 = 0x10000;
				inc2 = (w0 << 16) / sdlscreen->w;
				for ( i=sdlscreen->w; i>0; --i ) {
					while ( pos2 >= 0x10000L ) {
						pixel[0] = *srcp8++;
						pixel[1] = *srcp8++;
						pixel[2] = *srcp8++;
						pos2 -= 0x10000L;
					}
					*dstp16++ = gp2x_video_RGB_color16(pixel[0],pixel[1],pixel[2]);
					pos2 += inc2;
				}
			}
			else
			{
				srcp16 = (unsigned short*)srcp;
				dstp16 = (unsigned short*)dstp;
				pixel16 = 0;
				pos2 = 0x10000;
				inc2 = (w0 << 16) / sdlscreen->w;
				for ( i=sdlscreen->w; i>0; --i ) {
					while ( pos2 >= 0x10000L ) {
						pixel16 = *srcp16++;
						pos2 -= 0x10000L;
					}
					*dstp16++ = (unsigned short)((((pixel16)<<11)&0xf800f800)|(((pixel16)<<1)&0x7c007c0)|(((pixel16)>>10)&0x1f001f));
					pos2 += inc2;
				}
			}
			pos += inc;
		}

		SDL_UnlockSurface(sdlscreen);
	}

	if( framesToSkipText[0] != 0 )
	{
		gp2x_printf(NULL, 0,0,framesToSkipText);
		framesToSkipText[0] = 0;
		SDL_UpdateRect(sdlscreen, 0, 0, 0, 0);
		sleep(1);
	}
	else
	{
		SDL_UpdateRect(sdlscreen, 0, 0, 0, 0);
	}
#endif
}

/*----------------------------------------------------------------------
gpuOpenConfigure
----------------------------------------------------------------------*/
#if 0
BOOL DecToInt(const char *lpDec, long *lpInt)
{
	long temp;
	short data, sign;
	if (!lpDec)
		return (FALSE);
	if (!lpInt)
		return (FALSE);
	temp = 0;
	sign = 1;
	data = *lpDec++;
	if (data == '-') {
		data = *lpDec++;
		sign = -1;
	} else if (data == '+')
		data = *lpDec++;
	do {
		temp *= 10;
		if ((data >= '0') && (data <= '9'))
			temp += (data - '0');
		else
			return (FALSE);
		data = *lpDec++;
	} while (data);
	temp *= sign;
	(*lpInt) = temp;
	return (TRUE);
}
#endif

#if 0
#define	GPU_LOADFROMTEXT(id,x)											\
{																		\
	GetDlgItemText(hWnd, (id), szText, sizeof(szText));					\
	DecToInt(szText, (x));												\
}
#endif
void ConfigureCommand128(HWND hWnd)
{
#if 0
	char szText[256];
	long temp;
	GPU_LOADFROMTEXT(130, &DrawingCount[0]);
	GPU_LOADFROMTEXT(132, &DrawingCount[1]);
	GPU_LOADFROMTEXT(134, &DisplayCount[0]);
	GPU_LOADFROMTEXT(136, &WinWidth);
	GPU_LOADFROMTEXT(138, &WinHeight);
	WinStretch = IsDlgButtonChecked(hWnd, 139);
	WinEntire = IsDlgButtonChecked(hWnd, 140);
#endif
	gpuSaveConfig();
#if 0
	SendMessage(hWnd, WM_CLOSE, 0, 0);
#endif
}

#if 0
#define	GPU_SAVETOTEXT(id,x)											\
{																		\
	wsprintf(szText, "%d", (x));										\
	SetDlgItemText(hWnd, (id), szText);									\
}
#endif

void ConfigureInitDialog(HWND hWnd)
{
	char szText[256];
	long temp;
	gpuLoadConfig();
#if 0
	GPU_SAVETOTEXT(130, DrawingCount[0]);
	GPU_SAVETOTEXT(132, DrawingCount[1]);
	GPU_SAVETOTEXT(134, DisplayCount[0]);
	GPU_SAVETOTEXT(136, WinWidth);
	GPU_SAVETOTEXT(138, WinHeight);
	CheckDlgButton(hWnd, 139, WinStretch);
	CheckDlgButton(hWnd, 140, WinEntire);
#endif
}

#if 0
LRESULT CALLBACK ConfigureProc(HWND hWnd, UINT msg, WPARAM wParam,
							   LPARAM lParam)
{
	switch (msg) {
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case 128:
					ConfigureCommand128(hWnd);
					break;
			}
			break;
		case WM_CLOSE:
			EndDialog(hWnd, NULL);
			break;
		case WM_INITDIALOG:
			ConfigureInitDialog(hWnd);
			break;
	}
	return FALSE;
}
#endif

long gpuOpenConfigure(void)
{
#if 0
	DialogBox(WinInst, "CONFIGURE", GetActiveWindow(),
			  (DLGPROC) ConfigureProc);
#endif
	return (0);
}

/*----------------------------------------------------------------------
gpuOpenAbout
----------------------------------------------------------------------*/
#if 0
LRESULT CALLBACK AboutProc(HWND hWnd, UINT msg, WPARAM wParam,
						   LPARAM lParam)
{
	switch (msg) {
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case 128:
					SendMessage(hWnd, WM_CLOSE, 0, 0);
					break;
			}
			break;
		case WM_CLOSE:
			EndDialog(hWnd, NULL);
			break;
	}
	return FALSE;
}
#endif

void gpuOpenAbout(void)
{
//	DialogBox(WinInst, "ABOUT", GetActiveWindow(), (DLGPROC) AboutProc);
}

/* Legacy function */
void dtext(int x, int y, char * lpString)
{
	//while(VARIABLE_940T_FLIP == 1) {}

    gp2x_printf(NULL, 0, 0, lpString);
}


/* Legacy function */
void debugtext(int x, int y, char * lpString)
{
#if 0
    u16 lengthxx = strlen(lpString);
    u16 i, ascv;
    for(i = 0; i < lengthxx; i++)
    {
        ascv=(u16) lpString[i];
		
		// clear letter
		Letter(x + (i * 5), y, '&');

        Letter(x + (i * 5), y, ascv);
    }

	//gp2x_video_flip();
#endif
}
