/* GP2X minimal library v0.B
   Written by rlyeh, (c) 2005.

   Please check readme for licensing and other conditions. */

#ifndef __MINIMAL_H__
#define __MINIMAL_H__

#include <math.h>
#include <fcntl.h>
#include <linux/fb.h>
#include <pthread.h>
#include <signal.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdarg.h>

#define DISPLAY_X 320
#define DISPLAY_Y 240

#define MINILIB_VERSION  "GP2X minimal library v0.B by rlyeh, (c) 2005."

typedef struct gp2x_font        { int x,y,w,wmask,h,fg,bg,solid; unsigned char *data; } gp2x_font;
typedef struct gp2x_rect        { int x,y,w,h,solid; void *data; } gp2x_rect;

typedef struct gp2x_video_layer { unsigned char  *screen8;
                                  unsigned short *screen16;
                                  unsigned long  *screen32;

                                  unsigned long i[8];  //physical addresses of each buffer. they might have other usages too
                                  void *p[8];          //virtual address of each buffer
                                } gp2x_video_layer;


extern gp2x_video_layer         gp2x_video_RGB[1], gp2x_video_YUV[4];

extern void           gp2x_video_RGB_color8 (int, int, int, int);
extern unsigned short gp2x_video_RGB_color15(int, int, int, int);
extern unsigned short gp2x_video_RGB_color16(int, int, int);
extern void           gp2x_video_RGB_flip(int);
extern void	      gp2x_video_RGB_clearscreen16(void);

extern void         (*gp2x_blitter_rect)(gp2x_rect *);

extern void           gp2x_printf(gp2x_font *, int, int, const char *, ...);
extern void           gp2x_printf_init(gp2x_font *, int, int, void *, int, int, int);

extern void           gp2x_init(int, int, int, int, int, int, int);
extern void           gp2x_deinit(void);

#endif

